#include "ti83plus.inc"
.org $9D93
.dw  $6DBB
;Made to emulate xLIB's real(10...) command. Something about copy.
;Inputs: Ans=ProgName. If this arg is a num, assume to delete item.
;        X  =ProgNum
;
ProgramStart:
 in a,(6)
 ld (appbackupscreen),a
 bcall(_RclAns)
 ld a,(Op1)
 or a
 jr z,DelEntry
 cp 4
 ret nz   ;kill program if not either 0 nor 4.
 
 ld hl,Op1
 ld (hl),5
 inc hl
 ex de,hl
 ld a,(hl)
 and %00001111   ;doesn't need to be exact. Just prevent crash.
 ret z
 ld c,a
 ld b,0
 inc hl
 inc hl
 ldir
 xor a
 ld (de),a
 bcall(_ChkFindSym)
 ret c
 ld a,b
 or a
 ret z
 out (6),a
 ex de,hl
 ld b,10
 call ReadFlash
 ld b,a
 call ReadFlash
 ld (appbackupscreen+1),hl
  call GetProgFile
 ld hl,(appbackupscreen+1)
 jr nc,RestoreFile
 ld b,2
 call ReadFlash
 push de
  push hl
   ex de,hl
   bcall(_CreateProg)
  pop hl
 pop bc
 inc de
 inc de
 call GetAtHL
 ld (de),a
 inc de
 dec bc
 ld a,b
 or c
 jr nz,$-8
RestoreFile:
 ld a,(appbackupscreen)
 out (6),a
 ret
 
DelEntry:
 call GetProgFile
 ret c
 bcall(_DelVarArc)
 ret

ReadFlash:  ;B=#ofbytestoread. A=lastbyteread
 call GetAtHL
 ld e,d
 ld d,a
 djnz $-5
 ret

GetProgFile:
 bcall(_RclX)
 bcall(_ConvOp1)
 ld a,e
 cp 10
 jr nc,RestoreFile
 add a,$30
 ld de,Op1
 ld hl,TempProgName
 ld bc,8
 ldir
 ld (de),a
 bcall(_ChkFindSym)
 ret
GetAtHL:
 ld a,(hl)
 inc hl
 bit 7,h
 ret z
 push af
  in a,(6)
  inc a
  out (6),a
  res 7,h
 pop af
 ret
 
 
 

TempProgName:
.db 5,"XTEMP00"


.echo "-------------------------------\n"
.echo "Prog XCOPY size: "
.echo $-programstart
.echo " bytes.\n"
.echo "-------------------------------\n"
.end
